#!BPY

"""
Name: 'BLENDEARTH'
Blender: 234
Group: 'Wizards'
Tooltip: 'Create Texturated Terrain'
"""

######################################################
# BLENDEARTH v0.3
#
# Script for creating terrain
#
#####################################################
######################################################
# Author : Jean-Baptiste PERIN (jb_perin@yahoo.fr)
######################################################
import Blender
from Blender import *
from Blender.sys import join, dirname
import Array2
from Array2 import *
from Blender import Draw, BGL, Window
from Blender.BGL import *


dicImage={}
dicMaterial={}
dicFaces={}
dicMesh={}
dicFilter={}

meshterrain=None
taille = 6
denivelation = 2**taille
texnumsquare=32
altsnow = 70
altcold = 40
nivroche = 3.0
orientation = 1.0
altmax, altmin=0,0
nbEtage = 10

Map = [ [-1, -1,  -1, -1,  -1, -1], 
        [-1, 50,  20, 50,  20, -1],
        [-1, 70, -10, 70, -10, -1],
        [-1, 50,  20, 50,  20, -1],
        [-1,  1, -10,  1, -10, -1],
        [-1, 50,  20, 50,  20, -1],
        [-1,-10,  10,-10,  10, -1],
        [-1, 50,  20, 50,  20, -1],
        [-1, 70, -10, 70, -10, -1],
        [-1, 50,  20, 50,  20, -1],
        [-1, 70, -10, 70, -10, -1],
        [-1, -1,  -1, -1,  -1, -1]]

Map = [ [-1, -1, -1, -1, -1, -1], 
        [-1, -1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1, -1],
        [-1, -1, -1, -1, -1, -1]
      ]

Map = [ [-1,-1, -1, -1], 
        [-1,2, 2, -1],
        [-1,2, 2, -1],
        [-1,-1, -1, -1]
      ]

#Map = [ [-1, -1, -1], 
#        [-1, 1, -1],
#        [-1, -1, -1]
#      ]

#Map = [ [-1, -1], 
#        [-1, -1]]
        

largeurMap= len(Map[0])
longueurMap= len(Map)


print "largeurMap= ", largeurMap," longueurMap= ",  longueurMap
terrains=[]

def JoinZeroFilter(lamesh, x, y):
  def alt(x, y): return lamesh.verts[y*(largeurMap-1)*(2**taille)+x+y].co[2]
  maxX=((largeurMap-1)*(2**taille))
  maxY=((longueurMap-1)*(2**taille))
  val = 0.0
  if 1.0>abs(alt(x,y)):
    val = alt(x,y)
  else:
    val = (alt(x-1,y)+alt(x,y-1)+alt(x+1,y)+alt(x,y+1))/4
  return (val)

def SmoothFilter(lamesh, x, y):
  def alt(x, y): return lamesh.verts[y*(largeurMap-1)*(2**taille)+x+y].co[2]
  maxX=((largeurMap-1)*(2**taille))
  maxY=((longueurMap-1)*(2**taille))
  val = 0.0
  if x==maxX or x==0 or y==maxY or y == 0:
    val = alt(x,y)
  else:
    val = (alt(x,y)+alt(x-1,y)+alt(x,y-1)+alt(x+1,y)+alt(x,y+1))/5
  return (val)

def TerraceFilter(lamesh, x, y):
  global altmax, altmin
  def alt(x, y): return lamesh.verts[y*(largeurMap-1)*(2**taille)+x+y].co[2]
  maxX=((largeurMap-1)*(2**taille))
  maxY=((longueurMap-1)*(2**taille))
  val = 0.0
  hauteurEtage = (altmax-altmin)/nbEtage
  #print altmax,altmin,nbEtage
  zRel = alt(x,y) - altmin
  numEtage = int(zRel/hauteurEtage)
  if x==maxX or x==0 or y==maxY or y == 0:
    val = alt(x,y)
  else:
    val = numEtage*hauteurEtage+altmin
  return (val)

dicFilter={}
dicFilter["SmoothFilter"]=SmoothFilter
dicFilter["TerraceFilter"]=TerraceFilter
dicFilter["JoinZeroFilter"]=JoinZeroFilter

ListeFiltre=  ["TerraceFilter", "SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter","SmoothFilter", "JoinZeroFilter"]


def ApplyFilters(lamesh):
  n=taille
  #lamesh.removeAllKeys()
  for filtname in ListeFiltre:
    filter = dicFilter[filtname]
    for jj in range (0,(longueurMap-1)*(2**n)+1):
      for ii in range (0,(largeurMap-1)*(2**n)+1):
        #print "lamesh.verts[", ii, jj, "]", lamesh.verts[jj*(largeurMap-1)*(2**taille)+ii+jj].co
        lamesh.verts[jj*(largeurMap-1)*(2**taille)+ii+jj].co[2]=filter(lamesh, ii, jj)
    lamesh.update()
  #lamesh.insertKey()
        

def GetOrCreateMAT(matname):
  try:
    newmat = Material.Get(matname)
    print "material :"+ newmat.getName() + " exits"
  except:
    newmat = Material.New(matname)
    print "material :"+ newmat.getName() + " was created"
  newmat.mode = newmat.mode  | 2048
  newmat.setSpec(0.0)
  dicMaterial[newmat.getName()] = newmat 
  return newmat


def CreateMESH(meshname, terraindata):
  #global tab, taille
  global altmax, altmin
  me=NMesh.GetRaw()
  for ii in range ((2**taille)+1):
    for jj in range ((2**taille)+1):
      x=float(ii-(2**(taille-1)))
      y=float(jj-(2**(taille-1)))
      z=orientation*terraindata.getElement(ii,jj)/(16384.0/denivelation)
      altmax = max (z, altmax)
      altmin = min (z, altmin)
      #print "x= ", x, " y=", y, "z= ", z
      v=NMesh.Vert(x,y,z)
      me.verts.append(v)
  print "altmin = ", altmin, ", altmax = ", altmax
  me.name=meshname
  #D=NMesh.Modes
  #me.setMode('AutoSmooth')
  print "Mesh: "+ meshname+" was created ", me 
  dicMesh[meshname]=me
  me.name=meshname
  return(me)

def computeVertAlt(i,j):
  n=taille
  if i==(largeurMap-1)*(2**n):
    iTerr=i//(2**n)-1
    if j==(longueurMap-1)*(2**n):
      jTerr=j//(2**n)-1
      nTerrain = jTerr*(largeurMap-1) + iTerr
      xTerr, yTerr = (2**n),(2**n)
    else:
      jTerr=j//(2**n) 
      nTerrain = jTerr*(largeurMap-1) + iTerr
      xTerr, yTerr = (2**n),j%(2**n)
  else:
    iTerr, jTerr = i//(2**n), j//(2**n)
    if j==(longueurMap-1)*(2**n):
      jTerr=j//(2**n)-1
      iTerr=i//(2**n)
      nTerrain = jTerr*(largeurMap-1) + iTerr
      xTerr, yTerr = i%(2**n),(2**n)
    else:
      iTerr, jTerr = i//(2**n), j//(2**n)
      nTerrain = jTerr*(largeurMap-1) + iTerr
      xTerr, yTerr = i%(2**n),j%(2**n)

  #print "i, j = ", i, j
  #print "iTerr, jTerr = ", iTerr, jTerr,
  #print "nTerrain = ", nTerrain,
  #print "xTerr, yTerr = ", xTerr, yTerr
  leterrain = terrains[nTerrain]
  return (leterrain.getElement(xTerr, yTerr))

def CreateVerts(meshname):
  n=taille
  global altmax, altmin
  print "denivelation =" , denivelation
  me=NMesh.GetRaw()
  for jj in range ((longueurMap-1)*(2**n)+1):
    for ii in range ((largeurMap-1)*(2**n)+1):
      x=float(ii-2**(n-1))
      y=float(jj-2**(n-1))
      x=float(ii-((largeurMap-1)*(2**(taille))/2))
      y=float(jj-((longueurMap-1)*(2**(taille))/2))
      z=orientation*computeVertAlt(ii,jj)/(16384.0/denivelation)
      altmax = max (z, altmax)
      altmin = min (z, altmin)
      v=NMesh.Vert(x,y,z)
      me.verts.append(v)
  me.name=meshname
  #D=NMesh.Modes
  #me.setMode('AutoSmooth')
  print "altmin = ", altmin, ", altmax = ", altmax
  print "Mesh: "+ meshname+" was created ", me 
  dicMesh[meshname]=me
  me.name=meshname
  return(me)


#
#
# f1( (0,0), (0,1), (1,1)) et f2((0,0), (1,1), (1,0))
#
def CreateFaces(lamesh):
  n=taille
  #print len(lamesh.verts)
  for jj in range ((longueurMap-1)*(2**n)):
    for ii in range ((largeurMap-1)*(2**n)):
      #print "ii, jj = ", ii,jj, " face 1: verts[",jj*largeurMap*(2**n)+ii+jj,"], verts[",(jj+1)*largeurMap*(2**n)+(jj+1)+ii,"] verts [",(jj+1)*largeurMap*(2**n)+(jj+1)+(ii+1),"]"
      # FACE1
      f1=NMesh.Face()
      f1.v.append(lamesh.verts[jj*(largeurMap-1)*(2**n)+ii+jj])
      f1.v.append(lamesh.verts[(jj+1)*(largeurMap-1)*(2**n)+(jj+1)+ii])
      f1.v.append(lamesh.verts[(jj+1)*(largeurMap-1)*(2**n)+(jj+1)+(ii+1)])
      #f1.v.append(lamesh.verts[ii*(largeurMap-1)*(2**n)+ii+jj])
      #f1.v.append(lamesh.verts[(ii+1*(largeurMap-1)*(2**n)+(ii+1)+jj])
      #f1.v.append(lamesh.verts[(ii+1)*(largeurMap-1)*(2**n)+(ii+1)+(jj+1)])
      #f1.transp=NMesh.FaceTranspModes['SOLID']
      #f1.flag=NMesh.FaceFlags['ACTIVE']
      f1.smooth = 1
      # FACE2
      f2=NMesh.Face()
      f2.v.append(lamesh.verts[jj*(largeurMap-1)*(2**n)+ii+jj])
      f2.v.append(lamesh.verts[(jj+1)*(largeurMap-1)*(2**n)+(jj+1)+(ii+1)])
      f2.v.append(lamesh.verts[jj*(largeurMap-1)*(2**n)+jj+(ii+1)])
      #print "face 1: verts[",ii*largeurMap*(2**n)+ii+jj,"], verts[",(ii+1)*largeurMap*(2**n)+(ii+1)+jj,"], verts[",jj*largeurMap*(2**n)+jj+(ii+1),"]"
      #print "face 2: verts[",,"], verts[",,"], verts[",,"]"
      #f2.transp=NMesh.FaceTranspModes['SOLID']
      #f2.flag=NMesh.FaceFlags['ACTIVE']
      f2.smooth = 1
      lamesh.faces.append(f1)
      lamesh.faces.append(f2)


def MapFaces(lamesh):
  def computeXpos(laface):
    return (min(laface.v[0].co[0], laface.v[1].co[0], laface.v[2].co[0])%8) 
  def computeYpos(laface):
    return (min(laface.v[0].co[1], laface.v[1].co[1], laface.v[2].co[1])%8) 
  n=taille
  numface = 0
  for laface in lamesh.faces:
    mini,maxi = laface.v[0].co[2], laface.v[0].co[2]
    for ve in laface.v:
      mini=min (mini, ve.co[2])     
      maxi=max (maxi, ve.co[2])
    nivel = maxi - mini
    alt = (maxi + mini)/2
    numcarre = numface//2
    posY=numcarre/((2**n)*(largeurMap-1))
    posX=numcarre%((2**n)*(largeurMap-1))
    pastex = 1.0/float(texnumsquare)
    #print "numface = ",numface , "numcarre = ",numcarre , "posY = ", (posY%8)*pastex, "posX = ",(posX%8)*pastex 
    uv=[]
    valX =posX%texnumsquare
    valY =posY%texnumsquare 
    if valX == texnumsquare-1:
       valXp1 = texnumsquare
    else:
       valXp1 = (posX+1)%texnumsquare
    if valY == texnumsquare-1:
       valYp1 = texnumsquare
    else:
       valYp1 = (posY+1)%texnumsquare
    if (numface%2 == 0):
      #uv.append( (0.0,0.0))
      #uv.append( (0.0,texcoord))
      #uv.append( (texcoord,texcoord))
      uv.append( (valX * pastex,valY * pastex))
      uv.append( (valX * pastex,valYp1 * pastex))
      uv.append( (valXp1* pastex,valYp1 * pastex))
    else:
      #uv.append( (0.0,0.0))
      #uv.append( (texcoord,texcoord))
      #uv.append( (texcoord, 0.0))
      uv.append( (valX * pastex,valY * pastex))
      uv.append( (valXp1 * pastex,valYp1 * pastex))
      uv.append( (valXp1 * pastex, valY * pastex))
    laface.mat=0
    laface.uv=uv
    latexture = dicImage[computeImageName(nivel, alt)]
    laface.image = latexture
    #dicFaces[facename+"_r"]=f1

    C = NMesh.FaceModes
    laface.mode=C['LIGHT']
    laface.mode|=C['TEX']
    laface.mode|=C['TWOSIDE']

    laface.transp=NMesh.FaceTranspModes['SOLID']
    laface.flag=NMesh.FaceFlags['ACTIVE']
    #laface.smooth = 1

    numface = numface+1
  lamesh.update()
    

#def min(v1, v2):
  
def computeImageName(nivel, alt):
  filename = 'sable'
  if (0 > alt):
    return ('sable.jpg')
  if (3 > alt) and (nivroche>nivel):
    return ('sable.jpg')
  if (alt> altcold) and (altsnow > alt):
    return ('herbeneige.jpg')
  if (alt> altsnow):
    return ('snow.jpg')
  if (nivel > nivroche):
    return ('roche.jpg')
  else:
    return ('herbe2.jpg')

def GetOrCreateFACE2(meshname, facename):

  faces = []
  me=dicMesh[meshname]
  #im=dicImage[imagename]
  n=taille
  for ii in range ((2**n)):
    for jj in range ((2**n)):
      

      # FACE2
      f1=NMesh.Face()

      f1.v.append(me.verts[ii*(2**n)+ii+jj])
      f1.v.append(me.verts[(ii+1)*(2**n)+(ii+1)+jj])
      f1.v.append(me.verts[(ii+1)*(2**n)+(ii+1)+(jj+1)])
     
      mini = min(me.verts[ii*(2**n)+ii+jj].co[2], me.verts[(ii+1)*(2**n)+(ii+1)+jj].co[2], me.verts[(ii+1)*(2**n)+(ii+1)+(jj+1)].co[2])
      maxi = max(me.verts[ii*(2**n)+ii+jj].co[2], me.verts[(ii+1)*(2**n)+(ii+1)+jj].co[2], me.verts[(ii+1)*(2**n)+(ii+1)+(jj+1)].co[2])

      nivel = maxi - mini
      alt = (maxi + mini)/2
      
      uv1=[]
      uv1.append( (0.0,0.0))
      uv1.append( (texcoord,0.0))
      uv1.append( (texcoord,texcoord))
      f1.uv=uv1
      latexture = dicImage[computeImageName(nivel, alt)]
      f1.image = latexture
      dicFaces[facename+"_r"]=f1

      C = NMesh.FaceModes
      f1.mode=C['LIGHT']
      f1.mode|=C['TEX']
      f1.mode|=C['TWOSIDE']

      f1.transp=NMesh.FaceTranspModes['SOLID']
      f1.flag=NMesh.FaceFlags['ACTIVE']
      f1.smooth = 1
      faces.append(f1)

      # FACE2
      f2=NMesh.Face()
      f2.v.append(me.verts[ii*(2**n)+ii+jj])
      f2.v.append(me.verts[(ii+1)*(2**n)+(ii+1)+(jj+1)])
      f2.v.append(me.verts[ii*(2**n)+ii+(jj+1)])

      mini = min(me.verts[ii*(2**n)+ii+jj].co[2], me.verts[(ii+1)*(2**n)+(ii+1)+(jj+1)].co[2], me.verts[ii*(2**n)+ii+(jj+1)].co[2])
      maxi = max(me.verts[ii*(2**n)+ii+jj].co[2], me.verts[(ii+1)*(2**n)+(ii+1)+(jj+1)].co[2], me.verts[ii*(2**n)+ii+(jj+1)].co[2])

      nivel = maxi - mini
      alt = (maxi + mini)/2


      uv2=[]


      uv2.append( (0.0,0.0))
      uv2.append( (texcoord,texcoord))
      uv2.append( (0.0,texcoord))

      f2.uv=uv2
      latexture = dicImage[computeImageName(nivel, alt)]
      f2.image = latexture

      dicFaces[facename+"_l"]=f2
      f2.mode=C['LIGHT']
      f2.mode|=C['TEX']
      f2.mode|=C['TWOSIDE']

      f2.transp=NMesh.FaceTranspModes['SOLID']
      f2.flag=NMesh.FaceFlags['ACTIVE']
      f2.smooth = 1

      faces.append(f2)
  return (faces)

def TextureFACE(faces):

  #faces = []
  #f1=NMesh.Face()
  #f2=NMesh.Face()
  me=dicMesh[meshname]

  print "Mesh: ", meshname, " = ",me
  f1.v.append(me.verts[0])
  f1.v.append(me.verts[1])
  f1.v.append(me.verts[2])
  f2.v.append(me.verts[0])
  f2.v.append(me.verts[2])
  f2.v.append(me.verts[3])

  uv1=[]
  uv2=[]

  uv1.append( (0.0,0.0))
  uv1.append( (1.0,0.0))
  uv1.append( (1.0,1.0))

  uv2.append( (0.0,0.0))
  uv2.append( (1.0,1.0))
  uv2.append( (0.0,1.0))

  f1.uv=uv1
  f2.uv=uv2

  im=dicImage[imagename]
  f1.image = im
  f2.image = im

  dicFaces[facename+"_r"]=f1
  dicFaces[facename+"_l"]=f2
  C = NMesh.FaceModes
  f1.mode=C['LIGHT']
  f1.mode|=C['TEX']
  f1.mode|=C['TWOSIDE']
  f2.mode=C['LIGHT']
  f2.mode|=C['TEX']
  f2.mode|=C['TWOSIDE']

  f1.transp=NMesh.FaceTranspModes['SOLID']
  f1.flag=NMesh.FaceFlags['ACTIVE']
  f2.transp=NMesh.FaceTranspModes['SOLID']
  f2.flag=NMesh.FaceFlags['ACTIVE']
  faces.append(f1)
  faces.append(f2)

  return(faces)

# 
# Creation d'un object image
# 
def GetOrCreateIMAGE(imagename):
  filename=imagename+'.jpg'
  filepath='c:\\tmp\\' #???Mettre ici le chemin du fichier courant
  im=None

  try:
    im=Image.get(filename)
    dicImage[im.getName()]=im
  except NameError:
    try:
      im=Image.Load(join(filepath, filename))
      dicImage[im.getName()]=im
      print "image", im.getName(), " was Loaded"
    except IOError:
      print "unable lo load image", join(filepath, filename)
      pass
  
  return im

def ApplyTexture(materialname, imagename):
  tex = Texture.New()     
  tex.setType('Image')               
  tex.image = dicImage[imagename] 
  newmat = dicMaterial[materialname]              
  newmat.setTexture(0, tex)                                        
  mtex = newmat.getTextures()
  mtex[0].texco=Texture.TexCo.UV


#Map = [ [-1, -1, -1, -1, -1], 
#        [-1, 10, 10, 10, -1],
#        [-1, 10, 30, 10, -1],
#        [-1, 10, 20, 10, -1],
#        [-1, 10, 30, 10, -1],
#        [-1, 10, 10, 10, -1],
#        [-1, -1, -1, -1, -1]]


#Map = [ [-1,-1, -1, -1], 
#        [-1,10, -10, -1]]





material = GetOrCreateMAT("newmat") 
matname=material.getName()
idxtex = 0
for fichiertexture in ['herbeneige', 'sable','roche', 'snow', 'herbe2']:
  image = GetOrCreateIMAGE(fichiertexture)
  imname=image.getName()
  #tex = Texture.New()     
  #tex.setType('Image')               
  #tex.image = image 
  #newmat = material              
  #newmat.setTexture(idxtex, tex,Texture.TexCo.UV)                                        
  #mtex = newmat.getTextures()
  #mtex[0].texco=Texture.TexCo.UV
  #ApplyTexture(matname, imname)
  #idxtex = idxtex+1


def BuildTerrain ():
  global meshterrain
  meshterrains=[]
  nbTerrains=0
  for j in range (longueurMap-1):
    for i in range(largeurMap-1):
      #print "i = ",i, " j= ", j
      #print Map[j+1][i+1]
      #print nbTerrains
      terrains.append(Array2())
      terrains[nbTerrains].Init(taille)
      #initialisation du terrain
      if (j == 0) and (i==0):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, -1)
          terrains[nbTerrains].setElement(k, 2**taille, 0)
          terrains[nbTerrains].setElement(0,k, -1)
          terrains[nbTerrains].setElement(2**taille, k, 0)  
        terrains[nbTerrains].setElement(2**taille, 2**taille, int(Map[j+1][i+1]*(16384/denivelation)))
      elif (j == 0) and (i==largeurMap-2):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, -1)
          terrains[nbTerrains].setElement(k, 2**taille, 0)
          terrains[nbTerrains].setElement(0,k, terrains[nbTerrains-1].getElement(2**taille,k))
          terrains[nbTerrains].setElement(2**taille, k, -1)
        terrains[nbTerrains].setElement(0, 2**taille, int(Map[j+1][i]*(16384/denivelation)))
      #elif (j == 0) and not ((i==largeurMap-2) and (i!=0)):
      elif (j == 0) and not ((i==largeurMap-2) or (i==0)):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, -1)
          terrains[nbTerrains].setElement(k, 2**taille, 0)
          terrains[nbTerrains].setElement(0,k, terrains[nbTerrains-1].getElement(2**taille,k))
          terrains[nbTerrains].setElement(2**taille, k, 0)
        terrains[nbTerrains].setElement(0, 2**taille, int(Map[j+1][i]*(16384/denivelation)))
        terrains[nbTerrains].setElement(2**taille, 2**taille, int(Map[j+1][i+1]*(16384/denivelation)))

      elif (j == longueurMap-2) and (i==0):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, terrains[nbTerrains-(largeurMap-1)].getElement(k,2**taille))
          terrains[nbTerrains].setElement(k, 2**taille, -1)
          terrains[nbTerrains].setElement(0,k, -1)
          terrains[nbTerrains].setElement(2**taille, k, 0)
        terrains[nbTerrains].setElement(2**taille, 0, int(Map[j][i+1]*(16384/denivelation)))

      elif (j == longueurMap-2) and (i==largeurMap-2):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, terrains[nbTerrains-(largeurMap-1)].getElement(k,2**taille))
          terrains[nbTerrains].setElement(k, 2**taille, -1)
          terrains[nbTerrains].setElement(0,k, terrains[nbTerrains-1].getElement(2**taille, k))
          terrains[nbTerrains].setElement(2**taille, k, -1)
        terrains[nbTerrains].setElement(0, 0, int(Map[j][i]*(16384/denivelation)))

      elif (j == longueurMap-2) and not ((i==largeurMap-2) or (i==0)):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, terrains[nbTerrains-(largeurMap-1)].getElement(k,2**taille))
          terrains[nbTerrains].setElement(k, 2**taille, -1)
          terrains[nbTerrains].setElement(0,k, terrains[nbTerrains-1].getElement(2**taille, k))
          terrains[nbTerrains].setElement(2**taille, k, 0)
        terrains[nbTerrains].setElement(0, 0, int(Map[j][i]*(16384/denivelation)))
        terrains[nbTerrains].setElement(2**taille, 0  , int(Map[j][i+1]*(16384/denivelation)))
      #Bord Ouest
      elif (i==0) and not ((j==longueurMap-2) or (j==0)):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, terrains[nbTerrains-(largeurMap-1)].getElement(k,2**taille))
          terrains[nbTerrains].setElement(k, 2**taille, 0)
          terrains[nbTerrains].setElement(0,k, -1)
          terrains[nbTerrains].setElement(2**taille, k, 0)
        terrains[nbTerrains].setElement(2**taille, 0, int(Map[j][i+1]*(16384/denivelation)))
        terrains[nbTerrains].setElement(2**taille  ,2**taille, int(Map[j+1][i+1]*(16384/denivelation)))
      #Bord Est
      elif (i==largeurMap-2) and not ((j==longueurMap-2) or (j==0)):
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, terrains[nbTerrains-(largeurMap-1)].getElement(k,2**taille))
          terrains[nbTerrains].setElement(k, 2**taille, 0)
          terrains[nbTerrains].setElement(0,k, terrains[nbTerrains-1].getElement(2**taille, k))
          terrains[nbTerrains].setElement(2**taille, k, -1)
        terrains[nbTerrains].setElement(0, 0, int(Map[j][i]*(16384/denivelation)))
        terrains[nbTerrains].setElement(0  ,2**taille, int(Map[j+1][i]*(16384/denivelation)))
      #Middle
      else:
        for k in range (2**taille+1):
          terrains[nbTerrains].setElement(k, 0, terrains[nbTerrains-(largeurMap-1)].getElement(k,2**taille))
          terrains[nbTerrains].setElement(k, 2**taille, 0)
          terrains[nbTerrains].setElement(0,k, terrains[nbTerrains-1].getElement( 2**taille, k))
          terrains[nbTerrains].setElement(2**taille, k, 0)
        terrains[nbTerrains].setElement(0, 0, int(Map[j][i]*(16384/denivelation)))
        terrains[nbTerrains].setElement(0, 2**taille, int(Map[j+1][i]*(16384/denivelation)))
        terrains[nbTerrains].setElement(2**taille, 0, int(Map[j][i+1]*(16384/denivelation)))
        terrains[nbTerrains].setElement(2**taille,2**taille, int(Map[j+1][i+1]*(16384/denivelation)))

      terrains[nbTerrains].Build()
      #meshterrains.append(CreateMESH('Terrain'+str(i)+str(j), terrains[nbTerrains]))
      #faces = GetOrCreateFACE2('Terrain'+str(i)+str(j), 'laface')
      #for f in faces:
      #  meshterrains[nbTerrains].faces.append(f)
      #NMesh.PutRaw(meshterrains[nbTerrains],"Plane"+str(i)+str(j))
      #lobj=Object.GetSelected()
      #lobj[0].setLocation(i*(2**(taille)), j*(2**(taille)), 0)
     
        
      nbTerrains=nbTerrains+1

  meshterrain = CreateVerts("toto")
  #ApplyFilters(meshterrain)
  #meshterrain.materials.append(material)
  CreateFaces(meshterrain)
  #MapFaces(meshterrain)
  NMesh.PutRaw(meshterrain,"Plane.002")

  nbTerrains=0
  for j in range (longueurMap-1):
    for i in range(largeurMap-1):
      #meshterrains[nbTerrains].materials.append(material)    
      #meshterrains[1].materials.append(material)    
      terrains[nbTerrains].dispose() 
      #terrains[1].dispose() 
      nbTerrains=nbTerrains+1

#def TerraceTerrain():
  

EVENT_NUMBER_1 = 10
EVENT_NUMBER_2 = 11
EVENT_NUMBER_3 = 12
EVENT_BUTTON_4 = 13
EVENT_BUTTON_5 = 14
EVENT_BUTTON_6 = 15
EVENT_BUTTON_7 = 16
EVENT_TEXT_8 = 17
Object_Number_1 = Draw.Create(5)
Object_Number_2 = Draw.Create(10)
Object_Number_3 = Draw.Create(1)
Object_Button_4 = Draw.Create(0.0)
Object_Button_5 = Draw.Create(0.0)
Object_Button_6 = Draw.Create(0.0)
Object_Button_7 = Draw.Create(0.0)
Object_Text_8 = Draw.Create("")

def draw():
  global EVENT_NUMBER_1
  global EVENT_NUMBER_2
  global EVENT_NUMBER_3
  global EVENT_BUTTON_4
  global EVENT_BUTTON_5
  global EVENT_BUTTON_6
  global EVENT_BUTTON_7
  global EVENT_TEXT_8
  global Object_Number_1
  global Object_Number_2
  global Object_Number_3
  global Object_Button_4
  global Object_Button_5
  global Object_Button_6
  global Object_Button_7
  global Object_Text_8

  BGL.glClearColor(0.500000, 0.500000, 0.500000, 0.0)
  BGL.glClear(GL_COLOR_BUFFER_BIT)

  BGL.glColor3f(0.000000, 0.000000, 0.000000)
  Object_Number_1 = Draw.Number("Size", EVENT_NUMBER_1, 8, 112, 106, 20, Object_Number_1.val, 2.000000, 8.000000, "")
  Object_Number_2 = Draw.Number("Nb Stage", EVENT_NUMBER_2, 8, 80, 106, 20, Object_Number_2.val, 2.000000, 40.000000, "")
  Object_Number_3 = Draw.Number("Strength", EVENT_NUMBER_3, 8, 48, 107, 20, Object_Number_3.val, 0.000000, 20.000000, "")
  Object_Button_4 = Draw.Button("Create Mesh", EVENT_BUTTON_4, 120, 112, 85, 20, "")
  Object_Button_5 = Draw.Button("Terrace", EVENT_BUTTON_5, 120, 80, 85, 20, "")
  Object_Button_6 = Draw.Button("Smooth", EVENT_BUTTON_6, 120, 48, 85, 20, "")
  Object_Button_7 = Draw.Button("Texturate", EVENT_BUTTON_7, 120, 16, 85, 20, "")
  BGL.glRasterPos2i(0, 0)
  Object_Text_8 = Draw.Text("Output messages")


def event(event, value):
  if event == Draw.ESCKEY and not value: Draw.Exit()

def b_event(event):
  global taille, nbEtage, denivelation, ListeFiltre
  global EVENT_NUMBER_1
  global EVENT_NUMBER_2
  global EVENT_NUMBER_3
  global EVENT_BUTTON_4
  global EVENT_BUTTON_5
  global EVENT_BUTTON_6
  global EVENT_BUTTON_7
  global EVENT_TEXT_8
  global Object_Number_1
  global Object_Number_2
  global Object_Number_3
  global Object_Button_4
  global Object_Button_5
  global Object_Button_6
  global Object_Button_7
  global Object_Text_8

  if event == 0: pass
  elif event == EVENT_NUMBER_1:
    pass
  elif event == EVENT_NUMBER_2:
    pass
  elif event == EVENT_NUMBER_3:
    pass
  elif event == EVENT_BUTTON_4:
    print "mesh creation ", Object_Number_1.val
    taille = Object_Number_1.val
    denivelation = 2**(taille)
    BuildTerrain()
    pass
  elif event == EVENT_BUTTON_5:
    print "terrace mesh "
    nbEtage = Object_Number_2.val
    ListeFiltre=  ["TerraceFilter"]
    ApplyFilters(meshterrain)
    pass
  elif event == EVENT_BUTTON_6:
    print "smooth mesh"
    ListeFiltre=  ["SmoothFilter"]
    for i in range(Object_Number_3.val):
      ListeFiltre.append("SmoothFilter")
    ApplyFilters(meshterrain)
    pass
  elif event == EVENT_BUTTON_7:
    print "texturate mesh"
    meshterrain.materials.append(material)
    MapFaces(meshterrain)
    Blender.Redraw()
    pass
  elif event == EVENT_TEXT_8:
    pass
  Draw.Draw()

Draw.Register(draw, event, b_event)


Blender.Redraw()